################################################
#           MSc Course on Econometrics         #
#             Loukia Meligkotsidou             #
################################################

# linear regression under autocorrelation 
# time-series data
# y: nx1 vector of observations on the dependent variable
# X: nxk matrix of observations on k covariates


# Load data
# Load data
y <- as.matrix(read.table("C:/Loukia/R_labs_Econometrics/Lab2/Y.txt"))
X <- as.matrix(read.table("C:/Loukia/R_labs_Econometrics/Lab2/X.txt"))
cor(X)

dimX <- dim(X)
n=dimX[1]
k=dimX[2]
X <- cbind(1, X)  # Add a column of ones for the intercept term

# Least squares estimation
XX <- t(X) %*% X
XXinv <- solve(XX)
Xy <- t(X) %*% y
bhat <- XXinv %*% Xy
e <- y - X %*% bhat

sigmahat <- sum(e^2) / (n - k - 1)
Vbhat <- sigmahat * XXinv

# Breusch-Godfrey test for autocorrelation
p <- 1
Xauxiliary <- cbind(X[(p + 1):n, ], e[p:(n - p)])
yauxiliary <- e[(p + 1):n]
ahat <- solve(t(Xauxiliary) %*% Xauxiliary) %*% t(Xauxiliary) %*% yauxiliary
lm_model <- lm(yauxiliary ~ Xauxiliary-1)  # Fit auxiliary regression
B <- coef(lm_model)
R2 <- summary(lm_model)$r.squared
LM <- R2 * (n - p)
pvalue <- 1 - pchisq(LM, df = p)
pvalue

p <- 2
Xauxiliary <- cbind(X[(p + 1):n, ], e[(p - 1):(n - p)], e[p:(n - p + 1)])
yauxiliary <- e[(p + 1):n]
ahat <- solve(t(Xauxiliary) %*% Xauxiliary) %*% t(Xauxiliary) %*% yauxiliary
lm_model <- lm(yauxiliary ~ Xauxiliary - 1)  # Fit auxiliary regression
B <- coef(lm_model)
R2 <- summary(lm_model)$r.squared
LM <- R2 * (n - p)
pvalue <- 1 - pchisq(LM, df = p)
pvalue

# GLS estimator
yauxiliary <- e[2:n]
Z <- e[1:(n - 1)]
rhohat <- as.vector(solve(t(Z) %*% Z) %*% (t(Z) %*% yauxiliary))
rhohat

# Create a diagonal matrix with ones on the diagonal. Then set the first 
# sub-diagonal elements to -rhohat. 
P <- diag(1, n)  
P1=diag(1,n-1)
P1=cbind(P1,rep(0,n-1))
P1=rbind(rep(0,n),P1)
P=P-rhohat*P1
P

P[1, 1] <- sqrt(1 - rhohat^2)
PP <- t(P) %*% P
bhat_GLS <- solve(t(X) %*% PP %*% X) %*% t(X) %*% PP %*% y
estar <- P %*% y - P %*% X %*% bhat_GLS
sigmaehat <- sum(estar^2) / (n - k - 1)
Vbhat_GLS <- sigmaehat * solve(t(X) %*% PP %*% X)

bhat
diag(Vbhat)  # Estimate of variance ignoring autocorrelation

bhat_GLS
diag(Vbhat_GLS)  # Estimate of variance taking account of autocorrelation